Bug 1995112 (CVE-2021-39242) - CVE-2021-39242 haproxy: it can lead to a situation with an attacker-controlled HTTP Host header because a mismatch between Host and authority is mishandled
Summary: CVE-2021-39242 haproxy: it can lead to a situation with an attacker-controlle...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2021-39242
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1995113 1998200 2001963 2001965 2002703 2003162 2019913
Blocks: 1993521
TreeView+ depends on / blocked
 
Reported: 2021-08-18 13:21 UTC by Guilherme de Almeida Suckevicz
Modified: 2022-05-17 09:53 UTC (History)
13 users (show)

Fixed In Version: haproxy 2.4.3, haproxy 2.3.13, haproxy 2.2.16
Doc Type: If docs needed, set a value
Doc Text:
haproxy was found to be vulnerable to HTTP host header attack: This problem creates a scenario in which it's possible to drop the Host header and use the authority only after forwarding to a second http2 layer, possibly causing two differing values of Host at a different stage. The highest threat from this vulnerability is data integrity.
Clone Of:
Environment:
Last Closed: 2021-11-10 20:58:41 UTC
Embargoed:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2021:4118 0 None None None 2021-11-10 20:49:41 UTC
Red Hat Product Errata RHSA-2021:5208 0 None None None 2022-01-05 15:44:18 UTC

Description Guilherme de Almeida Suckevicz 2021-08-18 13:21:31 UTC
An issue was discovered in HAProxy 2.2 before 2.2.16, 2.3 before 2.3.13, and 2.4 before 2.4.3. It can lead to a situation with an attacker-controlled HTTP Host header, because a mismatch between Host and authority is mishandled.

Reference:
https://www.mail-archive.com/haproxy@formilux.org/msg41041.html

Upstream patch:
https://git.haproxy.org/?p=haproxy.git;a=commit;h=b5d2b9e154d78e4075db163826c5e0f6d31b2ab1

Comment 1 Guilherme de Almeida Suckevicz 2021-08-18 13:21:49 UTC
Created haproxy tracking bugs for this issue:

Affects: fedora-all [bug 1995113]

Comment 4 errata-xmlrpc 2021-11-10 20:49:39 UTC
This issue has been addressed in the following products:

  Red Hat OpenShift Container Platform 4.9

Via RHSA-2021:4118 https://access.redhat.com/errata/RHSA-2021:4118

Comment 5 Product Security DevOps Team 2021-11-10 20:58:39 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2021-39242

Comment 6 errata-xmlrpc 2022-01-05 15:44:16 UTC
This issue has been addressed in the following products:

  Red Hat OpenShift Container Platform 4.8

Via RHSA-2021:5208 https://access.redhat.com/errata/RHSA-2021:5208


Note You need to log in before you can comment on or make changes to this bug.